SystemOrganization addCategory: #ConfigurationOfVExample!

Object subclass: #ConfigurationOfVExample
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfVExample'!

!ConfigurationOfVExample class methodsFor: 'development support' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfVExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfVExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfVExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfVExample class methodsFor: 'metacello tool support' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfVExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfVExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfVExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfVExample class methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
project

	^self new project! !

!ConfigurationOfVExample class methodsFor: 'development support' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfVExample methodsFor: 'baselines' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VExample'.
		spec package: 'VExample'.
		spec group: 'default' with: #('VExample' ). ].
! !

!ConfigurationOfVExample methodsFor: 'symbolic versions' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfVExample methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/15/2012 16:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfVExample methodsFor: 'versions' stamp: 'JuanPabloSandovalA 8/15/2012 16:10'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : adding bar method'.
		spec author: 'JuanPabloSandovalA'.
		spec timestamp: '8/15/2012 16:10'.
		spec package: 'VExample' with: 'VExample-JuanPabloSandovalA.5'. ].
! !
